import type { SignatureAlgorithm } from './jwa';
import type { SignatureKey } from './jws';
import { type JWTPayload } from './types';
export interface TokenHeader {
    alg: SignatureAlgorithm;
    typ?: 'JWT';
}
export declare function isTokenHeader(obj: any): obj is TokenHeader;
export declare const sign: (payload: JWTPayload, privateKey: SignatureKey, alg?: SignatureAlgorithm) => Promise<string>;
export declare const verify: (token: string, publicKey: SignatureKey, alg?: SignatureAlgorithm) => Promise<any>;
export declare const decode: (token: string) => {
    header: any;
    payload: any;
};
